/********************************** (C) COPYRIGHT *******************************
* File Name          :
* Author             : WCH
* Version            : V1.0
* Date               :
* Description        : CH546IAP

APP뽫ʼַ޸0x104
APPжŹ̶16

*******************************************************************************/
#include "CH547.H"
#include "CH559_IAP.H"
#include "DEBUG.H"
#define THIS_ENDP0_SIZE      DEFAULT_ENDP0_SIZE
// 豸
UINT8C  MyDevDescr[] = {   0x12, 0x01, 0x10, 0x01,
                           0xFF, 0x80, 0x55, THIS_ENDP0_SIZE,
                           0x48, 0x43, 0x37, 0x55,
                           0x00, 0x01, 0x00, 0x00, 0x01, 0x01
                       };
// 
UINT8C  MyCfgDescr[] = {   0x09, 0x02, 0x20, 0x00, 0x01, 0x01, 0x00, 0x80, 0x32,
                           0x09, 0x04, 0x00, 0x00, 0x02, 0xFF, 0x80, 0x55, 0x00,
                           0x07, 0x05, 0x83, 0x02, 0x40, 0x00, 0x00,
                           0x07, 0x05, 0x02, 0x02, 0x40, 0x00, 0x00
                       };
// 
UINT8C  MyLangDescr[] = { 0x04, 0x03, 0x09, 0x04 };
// Ϣ
UINT8C  MyManuInfo[] = { 0x0E, 0x03, 'w', 0, 'c', 0, 'h', 0, '.', 0, 'c', 0, 'n', 0 };
// ƷϢ
UINT8C  MyProdInfo[] = { 0x0C, 0x03, 'C', 0, 'H', 0, '5', 0, '4', 0, '6', 0 };


UINT8X  Ep0Buffer[ THIS_ENDP0_SIZE + 2 ] _at_ 0x0000;                             // OUT&IN
UINT8X  Ep3Buffer[ MAX_PACKET_SIZE + 2 ] _at_ THIS_ENDP0_SIZE + 2;                // IN
UINT8X  Ep2Buffer[ MAX_PACKET_SIZE + 2 ] _at_ THIS_ENDP0_SIZE + MAX_PACKET_SIZE + 4; // OUT+IN


#define IAP_CODE_ADDR        (0x6000)
#define flag_ADDR        (IAP_CODE_ADDR-64)  //Ա־
#define writrable_ADDR        128

#define UsbSetupBuf     ((PUSB_SETUP_REQ)Ep0Buffer)
UINT8   SetupReqCode, SetupLen;
PUINT8  pDescr;
UINT8   UsbConfig, Ready;                                                // USBֵöɱ־
PUINT8C    pCode;
UINT8 USER_STARTUP[4];
UINT32 pack_cnt = 0;
UINT32 var_pack_cnt = 0;
iap_cmd1 xdata iap_cmd  _at_ 0x0100;                   //IAP


#define USER_ProgrameStartAddr    (0x100)
typedef void( *pTaskFn)( void );
pTaskFn tasksArr[1];

/*
ȷᵱоƬܷʱִflashдת֤־
*/
UINT8V en_Erase = 0; //ϻ·ָյָʹܲ־ΪҪ=д־

volatile UINT16 flash_addr = 0xffff; //iapдַ˳ģжϵַϷ

#pragma NOAREGS


/*******************************************************************************
* Function Name  : FLASH_Op_UnLock
* Description    : FLASH
* Input          : type: 
*						 bDATA_WE: DataFlash
*					     bCODE_WE: CodeFlash
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 FLASH_Op_UnLock( UINT8 type )
{
    bit e_all;
	
	if(en_Erase!=1)	//ת˳
		return(0xfc);
    
	/* жǷִFLASH */
    if(  en_Erase != 1)	//ûǰ
    {
        return( 0xFF );
    }

    /* Ͳֱӷ */
    if( ( type != bDATA_WE ) && ( type != bCODE_WE ) )
    {
        return( 0xFE );
    }

    if( !((iap_cmd.other.buf[0] == CMD_IAP_PROM) || (iap_cmd.other.buf[0] == CMD_IAP_ERASE)\
            || (iap_cmd.other.buf[0] == CMD_IAP_SUCCESS)) )
    {
        return( 0xFC );//벻
    }

    /* رȫж,ֹFlash */
    e_all = EA;
    EA = 0;

    /* 밲ȫģʽ */
    SAFE_MOD = 0x55;
    SAFE_MOD = 0xAA;
    GLOBAL_CFG |= type;

    /* ָȫж״̬ */
    EA = e_all;
    return( 0x00 );
}

/*******************************************************************************
* Function Name  : FLASH_Op_Type_Chk
* Description    : FLASHͼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
UINT8 FLASH_Op_Type_Chk( UINT16 addr )
{
	if(addr < BOOT_LOAD_ADDR){
		if( ( addr >= DATA_FLASH_ADDR ) )
		{
			/* DataFlash */
			return( bDATA_WE );
		}
		else
		{
			/* CodeFlash */
			return( bCODE_WE );
		}
	}
	else
		return(0xff);
}

/*******************************************************************************
* Function Name  : EraseBlock
* Description    : оƬĬϲһΪ64B
* Input          : Addr    оƬַ64BΪλ
* Output         : None
* Return         :         оƬ״̬
                    0x00   ɹ
                    0x01   ʱ
                    0x02   δ֪󣬲ʧ
*******************************************************************************/
UINT8    EraseBlock( UINT16 Addr )
{
    if((Addr < 128)|(Addr > IAP_CODE_ADDR)){
		return(0xfc);			//ַ
	}
	else{
		ROM_ADDR = Addr;
		ROM_BUF_MOD = 0X80;
		ROM_DAT_BUF = 0;

		if ( ROM_STATUS & bROM_ADDR_OK )
		{
			ROM_CTRL = ROM_CMD_ERASE;
			return((ROM_STATUS ^ bROM_ADDR_OK ) & 0x7F); //
		}
		else
		{
			return( 0x40 );
		}
	}
	return( 0xff );
}
/*******************************************************************************
* Function Name  : ProgWord
* Description    : оƬ̺
* Input          : Addr    оƬ̵ַַַΪżַ
                   Data    ݣWORDΪ׼
* Output         : None
* Return         :         оƬ̷״̬
                    0x00   ̳ɹ
                    0x01   ̳ʱ
                    0x02   δ֪󣬱ʧ
*******************************************************************************/
UINT8 ProgWord( UINT16 Addr, UINT8 Data )
{
	if(en_Erase!=1)	//ת˳
		return(0xfc);
	
	if( (Addr < 120)||(Addr > IAP_CODE_ADDR)){
		return(0xfc);//ַ
	}
	
    ROM_ADDR = Addr;
    ROM_BUF_MOD = bROM_BUF_BYTE;
    ROM_DAT_BUF = Data;

    if ( ROM_STATUS & bROM_ADDR_OK )
    {
        ROM_CTRL = ROM_CMD_PROG;
        return( ( ROM_STATUS ^ bROM_ADDR_OK ) & 0x7F );
    }
    else
        return( 0x40 );
}


/*******************************************************************************
* Function Name  : FlashVerify
* Description    : FlashУ
* Input          : Addr    оƬ̵ַַַΪżַ
                   pData   ݣWORDΪ׼
                   len     У鳤
* Output         : None
* Return         :         У״̬
                    0x00   Уɹ
                    0xff   Уʧ
*******************************************************************************/
UINT8 FlashVerify( UINT16 Addr, UINT8 *pData, UINT16 len )
{
    UINT16 i;
    pCode = (PUINT8C)( Addr );

    for( i = 0; i != len; i++ )
    {
        if( *pData != *pCode )
        {
            return 0xff;
        }

        pCode++;
        pData++;
    }

    return 0;
}

/*******************************************************************************
* Function Name  : CH55X_Respond
* Description    : IAPʱоƬӦ
* Input          : s ЧӦֽ
* Output         : None
* Return         : SBUF ڽֽ
*******************************************************************************/
void CH54X_Respond( UINT8 s )
{
    Ep3Buffer[0] =  s;
    Ep3Buffer[1] =  0;
    UEP3_T_LEN = 2;
    UEP3_CTRL = UEP3_CTRL & (~ MASK_UEP_T_RES) | UEP_T_RES_ACK;// ϴ
}
/*******************************************************************************
* Function Name  : CH559_USB_ISPDownload
* Description    : CH559غ
*                
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH55X_IAPDownload( void )
{
    UINT8  s=0xff;
    UINT16 i;
    UINT8 len;
    UINT16 addr=0xffff, tempdata;

    UINT8  status = 0xff;
    UINT8  type = 0;


    switch( iap_cmd.other.buf[0] )                                  // 
    {
        case CMD_IAP_PROM:                                              // ISP 
			if(en_Erase!=1){		//ʼд
				s= 0xfb ;											 //У
				goto PROM_end;
			}
			
            if(pack_cnt == 0)
            {
				addr = (iap_cmd.program.addr[0] | (UINT16)iap_cmd.program.addr[1] << 8);
				s = 0;
				if(addr != 0){	//Ȼ0ַ0Ϊ쳣
					s=0xfd;
					en_Erase=0;					
					goto PROM_end;
				}
                USER_STARTUP[0] = iap_cmd.program.buf[0];
                USER_STARTUP[1] = iap_cmd.program.buf[1];
                USER_STARTUP[2] = iap_cmd.program.buf[2];
                USER_STARTUP[3] = iap_cmd.program.buf[3];
            }
            else if(pack_cnt == 1)	//ingore
            {
				addr = (iap_cmd.program.addr[0] | (UINT16)iap_cmd.program.addr[1] << 8);
				s = 0;
				if(addr != 60){	//Ȼ60ַ0Ϊ쳣
					s=0xfd;
					en_Erase=0;
					goto PROM_end;
				}		
            }
            else	//ɱ
            {
                if(pack_cnt == 4)
                {
                    iap_cmd.program.buf[16] = USER_STARTUP[0];	//䵽0x100ַȥ
                    iap_cmd.program.buf[17] = USER_STARTUP[1];
                    iap_cmd.program.buf[18] = USER_STARTUP[2];
                    iap_cmd.program.buf[19] = USER_STARTUP[3];
                }

                len = iap_cmd.program.len;
                addr = (iap_cmd.program.addr[0] | (UINT16)iap_cmd.program.addr[1] << 8);

                if( 120 < addr <= flag_ADDR )
                {
					type = FLASH_Op_Type_Chk( addr );
					status = FLASH_Op_UnLock( type ); //дFlash
					if( status ){
						s=0xff;
						en_Erase=0;
						goto PROM_end;
					}
					else
						for( i = 0; i < len; i++ )
						{
							s = ProgWord( addr, iap_cmd.program.buf[i] );
							addr++;

							if( s != 0x00 )
							{
								en_Erase=0;
								goto PROM_end;
							}
						}
                }
                else
                {
					en_Erase=0;
                    s = 0xfb;
                }
            }
PROM_end:			
			SAFE_MOD = 0x55;
			SAFE_MOD = 0xAA;
			GLOBAL_CFG &= ~ ( bCODE_WE | bDATA_WE );
            CH54X_Respond( s );											 //У
            pack_cnt++;
            break;

        case CMD_IAP_ERASE:				// ISP 
			addr = (iap_cmd.erase.addr[0] | (UINT16)iap_cmd.erase.addr[1] << 8);//ַ
			if(addr == 0){
				addr=writrable_ADDR;//ǰ2page
				en_Erase=1;		//ʼд
			}
			else{	//ȻǴ0ַʼ,0쳣
				s = 0xfe;
				en_Erase=0;
				goto ERASE_end;
			}
            type = FLASH_Op_Type_Chk( addr );		//ʹflash
            status = FLASH_Op_UnLock( type );
            if( status ){
				s = 0xfe;
				en_Erase=0;
				goto ERASE_end;
            }
			
			s = EraseBlock( flag_ADDR );	//Ȳ־
			if(s == 0){						
				for( ; addr < ( flag_ADDR );  )//ȫ
				{
					s = EraseBlock( addr );
					addr += 64;
					if( s != 0 ){
						en_Erase=0;
						goto ERASE_end;
					}
				}
				
			}
ERASE_end:
            SAFE_MOD = 0x55;
            SAFE_MOD = 0xAA;
            GLOBAL_CFG &= ~ ( bCODE_WE | bDATA_WE );
            CH54X_Respond( s );
            break;

        case CMD_IAP_VERIFY:                                             // ISP У
            if(var_pack_cnt == 0)
            {
                s = 0;
            }
            else if(var_pack_cnt == 1)
            {
                s = 0;
            }
            else if(var_pack_cnt == 4)
            {
                s = 0;
            }
            else
            {
                addr = (iap_cmd.verify.addr[0] | (UINT16)iap_cmd.verify.addr[1] << 8);

                if(s <= (IAP_CODE_ADDR - 64))
                    s = FlashVerify( addr, &(iap_cmd.verify.buf[0]), iap_cmd.verify.len );
                else
                    s = 0;
            }

            CH54X_Respond( s );
            var_pack_cnt++;
            break;

        case CMD_IAP_END:                                                // ISP 
            UEP2_CTRL = (UEP2_CTRL & ~ MASK_UEP_R_RES) | UEP_R_RES_ACK;// ϴ
            break;

        case CMD_IAP_SUCCESS:
			if(en_Erase!=1){		//ʼд
				s=0xfc;
			}
			else{
				addr = flag_ADDR;
				type = FLASH_Op_Type_Chk( addr );
				status = FLASH_Op_UnLock( type );
				if( status ){
					s=0xfc;
				}
				else
					s=ProgWord( addr , 0xff );
			}
				
			en_Erase=0;
            SAFE_MOD = 0x55;
            SAFE_MOD = 0xAA;
            GLOBAL_CFG &= ~ ( bCODE_WE | bDATA_WE );
            CH54X_Respond( s );
            break;

        default:
//		printf("unsupport\n");
            CH54X_Respond( 0xff );                                       // δ֪
            break;
    }
}

void USB_DeviceInterrupt( void ) //interrupt INT_NO_USB using 1            /* USBжϷ,ʹüĴ1 */
{
    UINT8 i, len;

    if ( UIF_TRANSFER )                                                   // USB
    {
        if ( U_IS_NAK )                                                   // not enable for this example
        {
//          switch ( USB_INT_ST & ( MASK_UIS_TOKEN | MASK_UIS_ENDP ) ) {  // ƺͶ˵
//              case UIS_TOKEN_OUT | 2:                                     // endpoint 2# ˵´
//                  break;
//              case UIS_TOKEN_IN | 2:                                      // endpoint 2# ˵ϴ
//                  break;
//              case UIS_TOKEN_IN | 1:                                      // endpoint 1# ж϶˵ϴ
//                  break;
//              default:
//                  break;
//          }
        }
        else
        {
            switch ( USB_INT_ST & ( MASK_UIS_TOKEN | MASK_UIS_ENDP ) )     // ƺͶ˵
            {
                case UIS_TOKEN_OUT | 2:                                      // endpoint 2# ˵´
                    if ( U_TOG_OK )                                            // ͬݰ
                    {
//                      UEP2_CTRL ^= bUEP_R_TOG;                               // Զת
                        len = USB_RX_LEN;
                        memcpy( iap_cmd.other.buf, Ep2Buffer, len );
                        UEP2_CTRL = (UEP2_CTRL & ~ MASK_UEP_R_RES) | UEP_R_RES_NAK;// ֹͣϴ
                        CH55X_IAPDownload( );
                    }

                    break;

                case UIS_TOKEN_IN | 3:
                    UEP3_CTRL = (UEP3_CTRL & ~ MASK_UEP_T_RES) | UEP_T_RES_NAK;  // ͣϴ
                    UEP2_CTRL = (UEP2_CTRL & ~ MASK_UEP_R_RES) | UEP_R_RES_ACK;// 
                    break;

                case UIS_TOKEN_SETUP | 0:                                    // endpoint 0# SETUP
                    len = USB_RX_LEN;

                    if ( len == sizeof( USB_SETUP_REQ ) )                      // SETUP
                    {
                        SetupLen = UsbSetupBuf->wLengthL;

                        if ( UsbSetupBuf->wLengthH || SetupLen > 0x7F )
                        {
                            SetupLen = 0x7F;    // ܳ
                        }

                        len = 0;                                                 // ĬΪɹϴ0
                        SetupReqCode = UsbSetupBuf->bRequest;

                        if ( ( UsbSetupBuf->bRequestType & USB_REQ_TYP_MASK ) != USB_REQ_TYP_STANDARD )   /* Ǳ׼ */
                        {
                            len = 0xFF;
                        }
                        else                                                     // ׼
                        {
                            switch( SetupReqCode )                                 // 
                            {
                                case USB_GET_DESCRIPTOR:
                                    switch( UsbSetupBuf->wValueH )
                                    {
                                        case 1:                                          // 豸
                                            pDescr = (PUINT8)( &MyDevDescr[0] );
                                            len = sizeof( MyDevDescr );
                                            break;

                                        case 2:                                          // 
                                            pDescr = (PUINT8)( &MyCfgDescr[0] );
                                            len = sizeof( MyCfgDescr );
                                            break;

                                        case 3:                                          // ַ
                                            switch( UsbSetupBuf->wValueL )
                                            {
                                                case 1:
                                                    pDescr = (PUINT8)( &MyManuInfo[0] );
                                                    len = sizeof( MyManuInfo );
                                                    break;

                                                case 2:
                                                    pDescr = (PUINT8)( &MyProdInfo[0] );
                                                    len = sizeof( MyProdInfo );
                                                    break;

                                                case 0:
                                                    pDescr = (PUINT8)( &MyLangDescr[0] );
                                                    len = sizeof( MyLangDescr );
                                                    break;

                                                default:
                                                    len = 0xFF;                               // ֵַ֧
                                                    break;
                                            }

                                            break;

                                        default:
                                            len = 0xFF;                                  // ֵ֧
                                            break;
                                    }

                                    if ( SetupLen > len )
                                    {
                                        SetupLen = len;    // ܳ
                                    }

                                    len = SetupLen >= THIS_ENDP0_SIZE ? THIS_ENDP0_SIZE : SetupLen;  // δ䳤
                                    memcpy( Ep0Buffer, pDescr, len );                 /* ϴ */
                                    SetupLen -= len;
                                    pDescr += len;
                                    break;

                                case USB_SET_ADDRESS:
                                    SetupLen = UsbSetupBuf->wValueL;                  // ݴUSB豸ַ
                                    break;

                                case USB_GET_CONFIGURATION:
                                    Ep0Buffer[0] = UsbConfig;

                                    if ( SetupLen >= 1 )
                                    {
                                        len = 1;
                                    }

                                    break;

                                case USB_SET_CONFIGURATION:
                                    UsbConfig = UsbSetupBuf->wValueL;

                                    if(UsbConfig)
                                    {
                                        Ready = 1;
                                    }

                                    break;

                                case USB_CLEAR_FEATURE:
                                    if ( ( UsbSetupBuf->bRequestType & USB_REQ_RECIP_MASK ) == USB_REQ_RECIP_ENDP )    // ˵
                                    {
                                        switch( UsbSetupBuf->wIndexL )
                                        {
                                            case 0x82:
                                                UEP2_CTRL = UEP2_CTRL & ~ ( bUEP_T_TOG | MASK_UEP_T_RES ) | UEP_T_RES_NAK;
                                                break;

                                            case 0x02:
                                                UEP2_CTRL = UEP2_CTRL & ~ ( bUEP_R_TOG | MASK_UEP_R_RES ) | UEP_R_RES_ACK;
                                                break;

                                            case 0x81:
                                                UEP1_CTRL = UEP1_CTRL & ~ ( bUEP_T_TOG | MASK_UEP_T_RES ) | UEP_T_RES_NAK;
                                                break;

                                            case 0x01:
                                                UEP1_CTRL = UEP1_CTRL & ~ ( bUEP_R_TOG | MASK_UEP_R_RES ) | UEP_R_RES_ACK;
                                                break;

                                            default:
                                                len = 0xFF;                                 // ֵ֧Ķ˵
                                                break;
                                        }
                                    }
                                    else
                                    {
                                        len = 0xFF;    // Ƕ˵㲻֧
                                    }

                                    break;

                                case USB_GET_INTERFACE:
                                    Ep0Buffer[0] = 0x00;

                                    if ( SetupLen >= 1 )
                                    {
                                        len = 1;
                                    }

                                    break;

                                case USB_GET_STATUS:
                                    Ep0Buffer[0] = 0x00;
                                    Ep0Buffer[1] = 0x00;

                                    if ( SetupLen >= 2 )
                                    {
                                        len = 2;
                                    }
                                    else
                                    {
                                        len = SetupLen;
                                    }

                                    break;

                                default:
//                            len = 0xFF;                                       // ʧ
//                            printf("ErrEp0ReqCode=%02X\n",(UINT16)SetupReqCode);
                                    break;
                            }
                        }
                    }
                    else
                    {
                        len = 0xFF;                                            // SETUPȴ
//                    printf("ErrEp0ReqSize\n");
                    }

                    if ( len == 0xFF )                                       // ʧ
                    {
                        SetupReqCode = 0xFF;
                        UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_STALL | UEP_T_RES_STALL;  // STALL
                    }
                    else if ( len <= THIS_ENDP0_SIZE )                       // ϴݻ״̬׶η0Ȱ
                    {
                        UEP0_T_LEN = len;
                        UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;  // ĬݰDATA1
                    }
                    else                                                     // ´ݻ
                    {
                        UEP0_T_LEN = 0;  // Ȼδ״̬׶ΣǰԤϴ0ݰԷǰ״̬׶
                        UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;  // ĬݰDATA1
                    }

                    break;

                case UIS_TOKEN_IN | 0:                                     // endpoint 0# IN
                    switch( SetupReqCode )
                    {
                        case USB_GET_DESCRIPTOR:
                            len = SetupLen >= THIS_ENDP0_SIZE ? THIS_ENDP0_SIZE : SetupLen;  // δ䳤
                            memcpy( Ep0Buffer, pDescr, len );                    /* ϴ */
                            SetupLen -= len;
                            pDescr += len;
                            UEP0_T_LEN = len;
                            UEP0_CTRL ^= bUEP_T_TOG;                             // ת
                            break;

                        case USB_SET_ADDRESS:
                            USB_DEV_AD = USB_DEV_AD & bUDA_GP_BIT | SetupLen;
                            UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
                            break;

                        default:
                            UEP0_T_LEN = 0;                                      // ״̬׶жϻǿϴ0ݰƴ
                            UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
                            break;
                    }

                    break;

                case UIS_TOKEN_OUT | 0:                                    // endpoint 0# OUT
                    switch( SetupReqCode )
                    {
//                      case download:
//                          if ( U_TOG_OK ) {                                  // ͬݰ
//                              UEP0_CTRL ^= bUEP_R_TOG;                         // ת
//                                                                               //ȡ´;
//                              //UEP0_CTRL = UEP0_CTRL & bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK; // Ԥϴ0ݰDATA1Էǰ״̬׶
//                          }
//                          break;
                        case USB_GET_DESCRIPTOR:
                        default:
                            if ( U_TOG_OK )                                      // ͬݰ
                            {
//                              if ( USB_RX_LEN ) control_status_error;
//                              else control_ok;                                 // յ0Ȱʾƶ/ϴOK
                            }

//                          else control_status_error;
                            UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;           // ׼һƴ
                            break;
                    }

                    break;

                default:
                    break;
            }
        }

        UIF_TRANSFER = 0;                                             // жϱ־
    }
    else if ( UIF_BUS_RST )                                           // USB߸λ
    {
        UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
        UEP1_CTRL = bUEP_AUTO_TOG | UEP_R_RES_ACK;
        UEP2_CTRL = bUEP_AUTO_TOG | UEP_R_RES_ACK | UEP_T_RES_NAK;
        USB_DEV_AD = 0x00;
        UIF_SUSPEND = 0;
        UIF_TRANSFER = 0;
        UIF_BUS_RST = 0;                                              // жϱ־
    }
    else if ( UIF_SUSPEND )                                           // USB߹/
    {
        UIF_SUSPEND = 0;

        if ( USB_MIS_ST & bUMS_SUSPEND )                              // 
        {
//          while ( XBUS_AUX & bUART0_TX );                           // ȴ
//          SAFE_MOD = 0x55;
//          SAFE_MOD = 0xAA;
//          WAKE_CTRL = bWAK_BY_USB | bWAK_RXD0_LO;                   // USBRXD0źʱɱ
//          PCON |= PD;                                               // ˯
//          SAFE_MOD = 0x55;
//          SAFE_MOD = 0xAA;
//          WAKE_CTRL = 0x00;
        }
        else                                                          // 
        {
        }
    }
    else                                                              // ж,ܷ
    {
//        USB_INT_FG = 0xFF; //ѯ                                           // жϱ־
    }
}
/*******************************************************************************
* Function Name  : InitUSB_Device()
* Description    : USB豸ģʽ,豸ģʽշ˵ãжϿ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void    InitUSB_Device( void )                                      // ʼUSB豸
{
    IE_USB = 0;
    USB_CTRL = 0x00;                                                // 趨ģʽ
    UEP4_1_MOD = bUEP1_TX_EN;                                       // ˵1ϴIN
    UEP2_3_MOD = bUEP2_RX_EN | bUEP3_TX_EN;                        // ˵2´OUTϴIN
    UEP0_DMA = Ep0Buffer;
    UEP3_DMA = Ep3Buffer;
    UEP2_DMA = Ep2Buffer;
    UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
    UEP3_CTRL = bUEP_AUTO_TOG | UEP_R_RES_NAK | UEP_T_RES_NAK;
    UEP2_CTRL = bUEP_AUTO_TOG | UEP_R_RES_ACK | UEP_T_RES_NAK;
    USB_DEV_AD = 0x00;
    UDEV_CTRL = bUD_PD_DIS;                                         // ֹDP/DM
    USB_CTRL = bUC_DEV_PU_EN | bUC_INT_BUSY | bUC_DMA_EN;           // USB豸DMAжڼжϱ־δǰԶNAK
    UDEV_CTRL |= bUD_PORT_EN;                                       // USB˿
    USB_INT_FG = 0xFF;                                              // жϱ־
    USB_INT_EN = bUIE_SUSPEND | bUIE_TRANSFER | bUIE_BUS_RST;
    IE_USB = 1;
}

void main( )
{
    UINT16 i = 0;
    UINT16 j = 0;

    CfgFsys();

    pCode = (PUINT8C)( flag_ADDR );
    P1_MOD_OC |= (1 << 3);
    P1_DIR_PU |= (1 << 3);

    if(P1_3 != 0)
    {
        if(*pCode)
        {
            tasksArr[0] = (pTaskFn)(USER_ProgrameStartAddr);       //ûַ
            (tasksArr[0])( );
        }
    }

    InitUSB_Device( );

    while ( 1 )
    {
        j++;

        if( j > 30 )
        {
            j = 0;

            if( USB_INT_FG )
            {
                USB_DeviceInterrupt( );                                  // ѯusbж,鲻ҪƵѯ
            }
        }

        mDelayuS( 20 );
    }
}
